
/*
	Application that directs Baxter to show what SoundPlay is currently	playing.
	Similar to "QueryCLAmp", except that this application is smaller and uses
	the standard BeOS scripting mechanism.
*/


#include <Application.h>
#include <Message.h>
#include <stdio.h>

int main()
{
	BApplication app("application/x-vnd.abisoft-BaxterRemoteTest");
	
	BMessage question(B_GET_PROPERTY);
	question.AddSpecifier("info");
	question.AddSpecifier("track",int32(0));
	BMessage answer;

	if(B_OK==BMessenger("application/x-vnd.marcone-soundplay").SendMessage(&question, &answer,2E6,2E6))
	{
		double pitch;
		double time;
		double totaltime;
		const char *name;
		
		char buf[1024];
		buf[0] = '\0';

		if(	B_OK==answer.FindDouble("pitch",&pitch) &&
			B_OK==answer.FindDouble("abspos",&time) &&
			B_OK==answer.FindDouble("length",&totaltime) &&
			B_OK==answer.FindString("name",&name))
		{

			if(answer.FindBool("unknownlength"))
				sprintf(buf, "SoundPlay is currently playing \"%s\"",name);
			else if(pitch!=0.0)
				sprintf(buf, "SoundPlay is currently playing \"%s\", %ld:%02ld/%ld:%02ld (%ld:%02ld remaining)",
					name, 
					int(time)/60,
					int(time)%60,
					int(totaltime)/60,
					int(totaltime)%60,
					int(totaltime-time)/60,
					int(totaltime-time)%60);
		}
		printf("%s\n", buf);
		if(buf[0] == '\0')
			return 1;

		BMessage msg('bxtr');
		msg.AddString("command", buf);
	//	msg.AddBool("send_to_all", true);
	
		BMessenger messenger("application/x-vnd.abisoft-Baxter");
		messenger.SendMessage(&msg);
		return 0;
	}
	return 1;
}
